
_main:

;pic16f877_ds1621.c,19 :: 		void main() {
;pic16f877_ds1621.c,23 :: 		I2C_Initialize(100000);
	MOVLW      160
	MOVWF      FARG_I2C_Initialize_freq+0
	MOVLW      134
	MOVWF      FARG_I2C_Initialize_freq+1
	MOVLW      1
	MOVWF      FARG_I2C_Initialize_freq+2
	MOVLW      0
	MOVWF      FARG_I2C_Initialize_freq+3
	CALL       _I2C_Initialize+0
;pic16f877_ds1621.c,24 :: 		ds1621Init();
	CALL       _ds1621Init+0
;pic16f877_ds1621.c,26 :: 		while(1) {
L_main0:
;pic16f877_ds1621.c,27 :: 		T = readTemp();
	CALL       _readTemp+0
;pic16f877_ds1621.c,29 :: 		delay_ms(750);
	MOVLW      16
	MOVWF      R11+0
	MOVLW      57
	MOVWF      R12+0
	MOVLW      13
	MOVWF      R13+0
L_main2:
	DECFSZ     R13+0, 1
	GOTO       L_main2
	DECFSZ     R12+0, 1
	GOTO       L_main2
	DECFSZ     R11+0, 1
	GOTO       L_main2
	NOP
	NOP
;pic16f877_ds1621.c,30 :: 		}//while
	GOTO       L_main0
;pic16f877_ds1621.c,33 :: 		}//main
L_end_main:
	GOTO       $+0
; end of _main

_I2C_Initialize:

;pic16f877_ds1621.c,35 :: 		void I2C_Initialize(const unsigned long freq) {//Begin IIC as master
;pic16f877_ds1621.c,38 :: 		TRISC |= 0x18;//0b00011000;
	MOVLW      24
	IORWF      TRISC+0, 1
;pic16f877_ds1621.c,39 :: 		TRISA.F0 = 0;
	BCF        TRISA+0, 0
;pic16f877_ds1621.c,41 :: 		SSPCON  = 0b00101000;    //pg84/234
	MOVLW      40
	MOVWF      SSPCON+0
;pic16f877_ds1621.c,42 :: 		SSPCON2 = 0b00000000;    //pg85/234
	CLRF       SSPCON2+0
;pic16f877_ds1621.c,44 :: 		SSPADD = _XTAL_FREQ/(4*freq) - 1; //Setting Clock Speed pg99/234
	MOVF       FARG_I2C_Initialize_freq+0, 0
	MOVWF      R4+0
	MOVF       FARG_I2C_Initialize_freq+1, 0
	MOVWF      R4+1
	MOVF       FARG_I2C_Initialize_freq+2, 0
	MOVWF      R4+2
	MOVF       FARG_I2C_Initialize_freq+3, 0
	MOVWF      R4+3
	RLF        R4+0, 1
	RLF        R4+1, 1
	RLF        R4+2, 1
	RLF        R4+3, 1
	BCF        R4+0, 0
	RLF        R4+0, 1
	RLF        R4+1, 1
	RLF        R4+2, 1
	RLF        R4+3, 1
	BCF        R4+0, 0
	MOVLW      0
	MOVWF      R0+0
	MOVLW      36
	MOVWF      R0+1
	MOVLW      244
	MOVWF      R0+2
	MOVLW      0
	MOVWF      R0+3
	CALL       _Div_32x32_U+0
	DECF       R0+0, 0
	MOVWF      SSPADD+0
;pic16f877_ds1621.c,46 :: 		SSPSTAT = 0b00000000;    //pg83/234
	CLRF       SSPSTAT+0
;pic16f877_ds1621.c,48 :: 		return;
;pic16f877_ds1621.c,49 :: 		}//I2C_Initialize
L_end_I2C_Initialize:
	RETURN
; end of _I2C_Initialize

_I2C_Hold:

;pic16f877_ds1621.c,51 :: 		void I2C_Hold() {
;pic16f877_ds1621.c,55 :: 		delay_us(100);
	MOVLW      133
	MOVWF      R13+0
L_I2C_Hold3:
	DECFSZ     R13+0, 1
	GOTO       L_I2C_Hold3
;pic16f877_ds1621.c,60 :: 		return;
;pic16f877_ds1621.c,61 :: 		}//I2C_Hold
L_end_I2C_Hold:
	RETURN
; end of _I2C_Hold

_I2C_Start:

;pic16f877_ds1621.c,63 :: 		void I2C_Start() {
;pic16f877_ds1621.c,65 :: 		I2C_Hold();  //Hold the program is I2C is busy
	CALL       _I2C_Hold+0
;pic16f877_ds1621.c,66 :: 		SSPCON2.SEN = 1;     //Begin IIC pg85/234
	BSF        SSPCON2+0, 0
;pic16f877_ds1621.c,67 :: 		while(SSPCON2.SEN);
L_I2C_Start4:
	BTFSS      SSPCON2+0, 0
	GOTO       L_I2C_Start5
	GOTO       L_I2C_Start4
L_I2C_Start5:
;pic16f877_ds1621.c,69 :: 		return;
;pic16f877_ds1621.c,70 :: 		}//I2C_Start
L_end_I2C_Start:
	RETURN
; end of _I2C_Start

_I2C_Restart:

;pic16f877_ds1621.c,72 :: 		void I2C_Restart() {
;pic16f877_ds1621.c,74 :: 		I2C_Hold();
	CALL       _I2C_Hold+0
;pic16f877_ds1621.c,75 :: 		SSPCON2.RSEN = 1;
	BSF        SSPCON2+0, 1
;pic16f877_ds1621.c,76 :: 		while(SSPCON2.RSEN);
L_I2C_Restart6:
	BTFSS      SSPCON2+0, 1
	GOTO       L_I2C_Restart7
	GOTO       L_I2C_Restart6
L_I2C_Restart7:
;pic16f877_ds1621.c,78 :: 		return;
;pic16f877_ds1621.c,79 :: 		}//I2C_Restart
L_end_I2C_Restart:
	RETURN
; end of _I2C_Restart

_I2C_Stop:

;pic16f877_ds1621.c,81 :: 		void I2C_Stop() {
;pic16f877_ds1621.c,83 :: 		I2C_Hold(); //Hold the program is I2C is busy
	CALL       _I2C_Hold+0
;pic16f877_ds1621.c,84 :: 		SSPCON2.PEN = 1;    //End IIC pg85/234
	BSF        SSPCON2+0, 2
;pic16f877_ds1621.c,85 :: 		while(SSPCON2.PEN);
L_I2C_Stop8:
	BTFSS      SSPCON2+0, 2
	GOTO       L_I2C_Stop9
	GOTO       L_I2C_Stop8
L_I2C_Stop9:
;pic16f877_ds1621.c,87 :: 		return;
;pic16f877_ds1621.c,88 :: 		}//I2C_Stop
L_end_I2C_Stop:
	RETURN
; end of _I2C_Stop

_I2C_Write:

;pic16f877_ds1621.c,90 :: 		void I2C_Write(unsigned char datum) {
;pic16f877_ds1621.c,92 :: 		I2C_Hold(); // Hold the program is I2C is busy
	CALL       _I2C_Hold+0
;pic16f877_ds1621.c,93 :: 		SSPBUF = datum; //pg82/234
	MOVF       FARG_I2C_Write_datum+0, 0
	MOVWF      SSPBUF+0
;pic16f877_ds1621.c,94 :: 		while(SSPSTAT.BF);
L_I2C_Write10:
	BTFSS      SSPSTAT+0, 0
	GOTO       L_I2C_Write11
	GOTO       L_I2C_Write10
L_I2C_Write11:
;pic16f877_ds1621.c,96 :: 		I2C_Hold();
	CALL       _I2C_Hold+0
;pic16f877_ds1621.c,98 :: 		if (SSPCON2.ACKSTAT) PORTA.F0 = ~PORTA.F0;
	BTFSS      SSPCON2+0, 6
	GOTO       L_I2C_Write12
	MOVLW      1
	XORWF      PORTA+0, 1
L_I2C_Write12:
;pic16f877_ds1621.c,100 :: 		return;
;pic16f877_ds1621.c,101 :: 		}//I2C_Write
L_end_I2C_Write:
	RETURN
; end of _I2C_Write

_I2C_Read:

;pic16f877_ds1621.c,103 :: 		unsigned char I2C_Read(unsigned char ack) {
;pic16f877_ds1621.c,107 :: 		I2C_Hold();
	CALL       _I2C_Hold+0
;pic16f877_ds1621.c,108 :: 		SSPCON2.RCEN = 1;
	BSF        SSPCON2+0, 3
;pic16f877_ds1621.c,109 :: 		while(!SSPSTAT.BF);
L_I2C_Read13:
	BTFSC      SSPSTAT+0, 0
	GOTO       L_I2C_Read14
	GOTO       L_I2C_Read13
L_I2C_Read14:
;pic16f877_ds1621.c,111 :: 		I2C_Hold();
	CALL       _I2C_Hold+0
;pic16f877_ds1621.c,112 :: 		incoming = SSPBUF;         // get the data saved in SSPBUF
	MOVF       SSPBUF+0, 0
	MOVWF      I2C_Read_incoming_L0+0
;pic16f877_ds1621.c,114 :: 		I2C_Hold();
	CALL       _I2C_Hold+0
;pic16f877_ds1621.c,115 :: 		SSPCON2.ACKDT = (ack)?0:1; // check if ack bit received
	MOVF       FARG_I2C_Read_ack+0, 0
	BTFSC      STATUS+0, 2
	GOTO       L_I2C_Read15
	CLRF       ?FLOC___I2C_ReadT26+0
	GOTO       L_I2C_Read16
L_I2C_Read15:
	MOVLW      1
	MOVWF      ?FLOC___I2C_ReadT26+0
L_I2C_Read16:
	BTFSC      ?FLOC___I2C_ReadT26+0, 0
	GOTO       L__I2C_Read25
	BCF        SSPCON2+0, 5
	GOTO       L__I2C_Read26
L__I2C_Read25:
	BSF        SSPCON2+0, 5
L__I2C_Read26:
;pic16f877_ds1621.c,116 :: 		SSPCON2.ACKEN = 1;         // pg 85/234
	BSF        SSPCON2+0, 4
;pic16f877_ds1621.c,118 :: 		return incoming;
	MOVF       I2C_Read_incoming_L0+0, 0
	MOVWF      R0+0
;pic16f877_ds1621.c,119 :: 		}//I2C_Read
L_end_I2C_Read:
	RETURN
; end of _I2C_Read

_ds1621Init:

;pic16f877_ds1621.c,121 :: 		void ds1621Init() {
;pic16f877_ds1621.c,124 :: 		I2C_Start();
	CALL       _I2C_Start+0
;pic16f877_ds1621.c,125 :: 		I2C_Write(WRITE);  // Write mode
	MOVLW      144
	MOVWF      FARG_I2C_Write_datum+0
	CALL       _I2C_Write+0
;pic16f877_ds1621.c,126 :: 		I2C_Write(0xAC);   // send configuration register address (Access Config)
	MOVLW      172
	MOVWF      FARG_I2C_Write_datum+0
	CALL       _I2C_Write+0
;pic16f877_ds1621.c,127 :: 		I2C_Write(0x01);   // performs either continuous (0x00) or one-shot (0x01) conversion
	MOVLW      1
	MOVWF      FARG_I2C_Write_datum+0
	CALL       _I2C_Write+0
;pic16f877_ds1621.c,130 :: 		I2C_Restart();
	CALL       _I2C_Restart+0
;pic16f877_ds1621.c,131 :: 		I2C_Write(WRITE);  // Write mode
	MOVLW      144
	MOVWF      FARG_I2C_Write_datum+0
	CALL       _I2C_Write+0
;pic16f877_ds1621.c,132 :: 		I2C_Write(0xEE);   // send start temperature conversion command
	MOVLW      238
	MOVWF      FARG_I2C_Write_datum+0
	CALL       _I2C_Write+0
;pic16f877_ds1621.c,133 :: 		I2C_Stop();
	CALL       _I2C_Stop+0
;pic16f877_ds1621.c,135 :: 		return;
;pic16f877_ds1621.c,136 :: 		}//ds1621Init
L_end_ds1621Init:
	RETURN
; end of _ds1621Init

_readTemp:

;pic16f877_ds1621.c,138 :: 		int readTemp() {
;pic16f877_ds1621.c,142 :: 		I2C_Start();
	CALL       _I2C_Start+0
;pic16f877_ds1621.c,144 :: 		I2C_Write(WRITE);        // Write mode
	MOVLW      144
	MOVWF      FARG_I2C_Write_datum+0
	CALL       _I2C_Write+0
;pic16f877_ds1621.c,145 :: 		I2C_Write(0xAA);         // Access temperature register
	MOVLW      170
	MOVWF      FARG_I2C_Write_datum+0
	CALL       _I2C_Write+0
;pic16f877_ds1621.c,149 :: 		I2C_Restart();
	CALL       _I2C_Restart+0
;pic16f877_ds1621.c,150 :: 		I2C_Write(WRITE | 0x01); // Read mode
	MOVLW      145
	MOVWF      FARG_I2C_Write_datum+0
	CALL       _I2C_Write+0
;pic16f877_ds1621.c,151 :: 		tH = I2C_Read(1);        // Read temperature high, ack
	MOVLW      1
	MOVWF      FARG_I2C_Read_ack+0
	CALL       _I2C_Read+0
	MOVF       R0+0, 0
	MOVWF      readTemp_tH_L0+0
;pic16f877_ds1621.c,152 :: 		tL = I2C_Read(0);        // Read temperature low, nack
	CLRF       FARG_I2C_Read_ack+0
	CALL       _I2C_Read+0
	MOVF       R0+0, 0
	MOVWF      readTemp_tL_L0+0
;pic16f877_ds1621.c,154 :: 		I2C_Stop();
	CALL       _I2C_Stop+0
;pic16f877_ds1621.c,156 :: 		return (tH<<8) | tL;
	MOVF       readTemp_tH_L0+0, 0
	MOVWF      R0+1
	CLRF       R0+0
	MOVF       readTemp_tL_L0+0, 0
	IORWF      R0+0, 1
	MOVLW      0
	IORWF      R0+1, 1
;pic16f877_ds1621.c,157 :: 		}//readTemp
L_end_readTemp:
	RETURN
; end of _readTemp

_readCntr:

;pic16f877_ds1621.c,159 :: 		unsigned char readCntr() {
;pic16f877_ds1621.c,163 :: 		I2C_Start();
	CALL       _I2C_Start+0
;pic16f877_ds1621.c,165 :: 		I2C_Write(WRITE);        // Write mode
	MOVLW      144
	MOVWF      FARG_I2C_Write_datum+0
	CALL       _I2C_Write+0
;pic16f877_ds1621.c,166 :: 		I2C_Write(0xA8);         // Access counter register
	MOVLW      168
	MOVWF      FARG_I2C_Write_datum+0
	CALL       _I2C_Write+0
;pic16f877_ds1621.c,170 :: 		I2C_Restart();
	CALL       _I2C_Restart+0
;pic16f877_ds1621.c,171 :: 		I2C_Write(WRITE | 0x01); // Read mode
	MOVLW      145
	MOVWF      FARG_I2C_Write_datum+0
	CALL       _I2C_Write+0
;pic16f877_ds1621.c,172 :: 		out = I2C_Read(0);       // Read counter register, nack
	CLRF       FARG_I2C_Read_ack+0
	CALL       _I2C_Read+0
	MOVF       R0+0, 0
	MOVWF      readCntr_out_L0+0
;pic16f877_ds1621.c,174 :: 		I2C_Stop();
	CALL       _I2C_Stop+0
;pic16f877_ds1621.c,176 :: 		return out;
	MOVF       readCntr_out_L0+0, 0
	MOVWF      R0+0
;pic16f877_ds1621.c,177 :: 		}//readCntr
L_end_readCntr:
	RETURN
; end of _readCntr
